/* 
 This example shows the arduino is monitoring the signal from Raspberry Pi.
 If it receive a singla, it plays a sound. 
 
 Jieliang (Rodger) Luo
 April 2018
*/

#include <Wire.h>
#include <Zumo32U4.h>

Zumo32U4Buzzer buzzer;
Zumo32U4Motors motors;

// Store this song in program space using the PROGMEM macro.
// Later we will play it directly from program space, bypassing
// the need to load it all into RAM first.
const char fugue[] PROGMEM =
//mario bros. song:
  "! O5 L4 E8E8.E8.. C8E8. G..  <G. C<G<E<A8.<B8.<A#8<A8.<G8E8G8A8F8G8E8C8.D8<B C<G<E<A8.<B8.<A#8<A8.<G8E8G8A8F8G8E8C8.D8<B. R G8F#8F8D#8E8. <A8C8.<A8C8D R16 G8F#8F8D#8E >C8 R16 >C8 R64 >C R G8F#8F8D#8E. <A8C8.<A8C8D. D#DC ";

  //star wars song: "! O5 L4 <G<G<G <D#8. <A#16 <G <D#8. <A#16 <G R DDD D#8 <A#8 <F# <D#8 <A#8 <G R G <G8<G8 G F#8F8E16D#16E <D#8 <F# <D#8 <F#8 <A# <G8 <A#8 D R G <G8<G8 G F#8F8E16D#16E R16 <G#8 C# C8 <B8 <A#16<A16<A# R16<D#8<F# <D#8. <A#16<G <D#8. <A#16 <G"
boolean play_sound = false;

void setup()       // run once, when the sketch starts
{
  Serial.begin(9600);
}

void loop()        // run over and over again
{
  //Listening from Python
  if(Serial.read() == '1'){
     play_sound = true;
  }
  
  if(play_sound == true){
    // Start playing a tone with frequency 440 Hz at maximum
    // volume (15) for 200 milliseconds.
    buzzer.playFrequency(440, 200, 15);
  
    // Delay to give the tone time to finish.
    delay(1000);
  
    // Start playing note A in octave 4 at maximum volume
    // volume (15) for 2000 milliseconds.
    buzzer.playNote(NOTE_A(4), 2000, 15);
  
    // Wait for 200 ms and stop playing note.
    delay(200);
    buzzer.stopPlaying();
  
    delay(1000);
  
    // Start playing a fugue from program space.
    buzzer.playFromProgramSpace(fugue);
  
    // Wait until it is done playing.
    while(buzzer.isPlaying()){

      
  // Run left motor forward.
  ledYellow(1);
  for (int speed = 0; speed <= 300; speed++)
  {
    motors.setLeftSpeed(speed);
    delay(1);
  }
  for (int speed = 300; speed >= 0; speed--)
  {
    motors.setLeftSpeed(speed);
    delay(1);
  }

  // Run left motor backward.
  ledYellow(0);
  for (int speed = 0; speed >= -300; speed--)
  {
    motors.setLeftSpeed(speed);
    delay(1);
  }
  for (int speed = -300; speed <= 0; speed++)
  {
    motors.setLeftSpeed(speed);
    delay(1);
  }

  // Run right motor forward.
  ledYellow(1);
  for (int speed = 0; speed <= 300; speed++)
  {
    motors.setRightSpeed(speed);
    delay(1);
  }
  for (int speed = 300; speed >= 0; speed--)
  {
    motors.setRightSpeed(speed);
    delay(1);
  }

  // Run right motor backward.
  ledYellow(0);
  for (int speed = 0; speed >= -300; speed--)
  {
    motors.setRightSpeed(speed);
    delay(1);
  }
  for (int speed = -300; speed <= 0; speed++)
  {
    motors.setRightSpeed(speed);
    delay(1);
  }
   // Run left motor backward.
  ledYellow(0);
  for (int speed = 0; speed >= -300; speed--)
  {
    motors.setLeftSpeed(speed);
    delay(1);
  }
  for (int speed = -300; speed <= 0; speed++)
  {
    motors.setLeftSpeed(speed);
    delay(1);
  }

    // Run left motor forward.
  ledYellow(1);
  for (int speed = 0; speed <= 300; speed++)
  {
    motors.setLeftSpeed(speed);
    delay(1);
  }
  for (int speed = 300; speed >= 0; speed--)
  {
    motors.setLeftSpeed(speed);
    delay(1);
  }
// Run right motor backward.
  ledYellow(0);
  for (int speed = 0; speed >= -300; speed--)
  {
    motors.setRightSpeed(speed);
    delay(1);
  }
  for (int speed = -300; speed <= 0; speed++)
  {
    motors.setRightSpeed(speed);
    delay(1);
  }

  
  // Run right motor forward.
  ledYellow(1);
  for (int speed = 0; speed <= 300; speed++)
  {
    motors.setRightSpeed(speed);
    delay(1);
  }
  for (int speed = 300; speed >= 0; speed--)
  {
    motors.setRightSpeed(speed);
    delay(1);
  }

  }
  
  delay(500);
      
      
      
      
      
      }
  
    delay(1000);
    
    play_sound = false;
  }

